# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ......core.datetime_utils import serialize_datetime
from .invoice_destination import InvoiceDestination

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class InvoiceDestinationMetadata(pydantic.BaseModel):
    invoice_destination: InvoiceDestination = pydantic.Field(
        description="Defines which third-party service this invoice was created in"
    )
    source_id: str = pydantic.Field(description="The id of the invoice in the third-party service")
    source_customer_id: str = pydantic.Field(
        description="The id of the customer that the invoice is attributed to in the third-party service"
    )
    destination_status: typing.Optional[str] = pydantic.Field(
        default=None, description="The status of the invoice in the third-party service"
    )

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        json_encoders = {dt.datetime: serialize_datetime}
